''This code example is from Propeller Education Kit Labs: Fundamentals, v1.1.
''A .pdf copy of the book is available from www.parallax.com, and also through
''the Propeller Tool software's Help menu (v1.2.6 or newer).
''
'' File: ButtonShiftSpeed.spin
'' LED pattern is shifted left to right at variable speeds controlled by pushbuttons.

VAR

    Byte pattern, divide

PUB ShiftLedsLeft

    dira[16..23] ~~
    divide := 5

    repeat '100
       
       if pattern == 0
          pattern := %11000000

       if ina[26] == 1
          divide ++
          divide <#= 254
       elseif ina[27] == 0
          divide --
          divide #>= 1

       waitcnt(clkfreq/divide + cnt)
       outa[16..23] := pattern
       pattern >>= 1